#include "main.h"
//======================================================================
inline static double getTime(void) // time in seconds
{
	struct timeval tv;
	gettimeofday(&tv,(struct timezone *)0);
	return tv.tv_sec+1e-6*tv.tv_usec;
} 
//======================================================================
typedef struct _ThreadInfo
{
	pthread_t th;
	int size,nbThreads;
	double *A,*B,*C;
	int index;
} ThreadInfo;

void *task2(void *data)
{
	ThreadInfo *info=(ThreadInfo *)data;
	for(int i=info->index;i<info->size*info->size;i+=info->nbThreads)
	{
		  int row=i/info->size;
		  int column=i-(row*info->size);
		  double sum=0.0;
		  for(int k=0;k<info->size;++k)
			{
				sum+=info->A[row*info->size+k]*info->B[k*info->size+column];
			}
		  info->C[i]=sum;
	  }
	return (void *)0;
}
//======================================================================
//							MAIN
//======================================================================
int main(int argc, char **argv)
{
  int ok;	

  int i,size,nbThreads;
  if((argc!=3)||(sscanf(argv[1],"%d",&size)!=1)||(sscanf(argv[2],"%d",&nbThreads)!=1))
					{ fprintf(stderr,"usage: %s size nb_threads\n",argv[0]); exit(1); }				
					
  double *A=(double *)malloc(size*size*sizeof(double));
  double *B=(double *)malloc(size*size*sizeof(double));
  double *C=(double *)malloc(size*size*sizeof(double));
  
  srand(time((time_t *)0));
  
  for(i=0;i<size*size;++i)
    {
		A[i]=rand()/(double)RAND_MAX;
		B[i]=rand()/(double)RAND_MAX;
		C[i]=0.0;
    }
    
  ThreadInfo *threads=(ThreadInfo *)malloc(nbThreads*sizeof(ThreadInfo));
  double t0=getTime();
  for(i=0;i<nbThreads;++i)
    {
			threads[i].size=size;
			threads[i].nbThreads=nbThreads;
			threads[i].A=A;
			threads[i].B=B;
			threads[i].C=C;
			threads[i].index=i;
			ok = pthread_create(&threads[i].th,(const pthread_attr_t *)0, &task2,threads+i);
									if( ok == -1 ) { perror("thread create"); exit(1); }

    }
  for(i=0;i<nbThreads;++i)
    {
			ok = pthread_join(threads[i].th,(void **)0);
									if( ok == -1 ) { perror("thread create"); exit(1); }
    }
  double t1=getTime();
  free(threads);
  free(A);
  free(B);
#if 0
  for(i=0;i<size;++i)
    {
    for(int j=0;j<size;++j)
      {
		printf("%g ",C[i*size+j]);
      }
    printf("\n");
    }
#endif
  free(C);
  printf("duration: %g s\n",t1-t0);
			
return EXIT_SUCCESS;
}
//^^^^^^^^^^^^^^^^^^^^^^^^^^ EOF ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

